package com.loafle.commons.server.socket.handler.codec;

import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToMessageDecoder;

import java.util.List;

abstract class SocketProtocolHandler extends MessageToMessageDecoder<SocketFrame> {
  @Override
  protected void decode(ChannelHandlerContext ctx, SocketFrame frame, List<Object> out) throws Exception {
    if (frame instanceof PingSocketFrame) {
      frame.content().retain();
      ctx.channel().writeAndFlush(new PongSocketFrame(frame.content()));
      return;
    }
    if (frame instanceof PongSocketFrame) {
      // Pong frames need to get ignored
      return;
    }

    out.add(frame.retain());
  }

  @Override
  public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
    ctx.fireExceptionCaught(cause);
    ctx.close();
  }
}